


function [usnr_map b1_map loss_map]=compute_usnr_unacc_fast_v2(nx,ny,nz,nchannels,datadir,b1target,mask,lossmatfilepref)
% function [usnr_map b1_map loss_map]=compute_usnr_unacc_fast_v2(nx,ny,nz,nchannels,datadir,b1target,mask,lossmatfilepref)

if matlabpool('size')==0
     matlabpool open 12;  % max number of workers on the icepuffs
end

% read B1- map
b1maps=read_b1maps(datadir,1,nchannels,nx,ny,nz);

% read global SAR matrix
lossmat=reshape( read_ddata( sprintf('%s/%s.dat',datadir,lossmatfilepref),-1 ),nchannels,2*nchannels );
lossmat=lossmat(:,1:2:end) + 1j*lossmat(:,2:2:end);
q=lossmat;

ind=find(mask>0);
[indx indy indz]=ind2sub( [nx ny nz],ind );

clear tmp1 tmp2 tmp3;

parfor_progress(size(ind,1));  % initialize

parfor i=1:size(ind,1)
    
    parfor_progress;  % print progress
    
    xpix = indx(i,1);
    ypix = indy(i,1);
    zpix = indz(i,1);
    A = compute_system_matrix(b1maps,xpix,ypix,zpix);

    A2 = [q A.' ; conj(A) 0];
    b2 = [zeros(nchannels,1) ; b1target ];
    
    % sol = A2 \ b2;
    sol = pinv(A2) * b2;
    
    rf = conj( sol(1:nchannels) );
    
    b1=A*rf;
    loss_=real( (rf.')*q*conj(rf) );
    
    tmp1(i,1)=abs(b1)/sqrt(loss_);
    tmp2(i,1)=b1;
    tmp3(i,1)=loss_;
    
end

parfor_progress(0);  % clean up

usnr_map=zeros(nx,ny,nz);
usnr_map(ind)=tmp1;

if nargout>1
    b1_map=zeros(nx,ny,nz);
    b1_map(ind)=tmp2;
end

if nargout>2
    loss_map=zeros(nx,ny,nz);
    loss_map(ind)=tmp3;
end

% matlabpool close;

% fprintf('\n');




        
        
        




